package ninja.thefirearchmage.games.fourtykcalculator;

import lombok.Getter;

import java.util.HashSet;
import java.util.Optional;
import java.util.Set;

@Getter
public class DefensiveProfile {
    private final int toughness;
    private final int normalSave;
    private final int wounds;
    private final int bodies;
    private final Optional<InvulnerableSave> invulnerableSave;
    private final Optional<FeelNoPainEffect> feelNoPain;
    private final Set<UnitTypeKeyword> unitTypeKeywords;

    public DefensiveProfile(int toughness, int wounds, int bodies, int normalSave) {
        this(toughness, wounds, bodies, normalSave, Optional.empty(), Optional.empty());
    }

    public DefensiveProfile(int toughness, int wounds, int bodies, int normalSave, Optional<InvulnerableSave> invulnerableSave, Optional<FeelNoPainEffect> feelNoPain) {
        this.toughness = toughness;
        this.wounds = wounds;
        this.normalSave = normalSave;
        this.invulnerableSave = invulnerableSave;
        this.feelNoPain = feelNoPain;
        this.bodies = bodies;
        this.unitTypeKeywords = new HashSet<>();
    }

    public DefensiveProfile withUnitTypes(Set<UnitTypeKeyword> types) {
        this.unitTypeKeywords.addAll(types);
        return this;
    }
}
