package ninja.thefirearchmage.games.fourtykcalculator.utils;

public class MathUtils {
    /**
     * Returns an integer from rounding down a double, applying the following rounding method:
     * if decimal fraction <=0.5 return the number by default
     * if decimal fraction >0.5 return the number by excess
     * The method is name after the {@link java.math.RoundingMode} used in {@link java.math.BigDecimal}, but
     * this method uses way less memory and cpu to accomplish the same, due to a very different use case
     */
    public static int roundHalfDown(double d) {
        double integerPart = Math.floor(d);
        double decimalPart = d - integerPart;
        if (decimalPart <= 0.5) {
            return (int) integerPart;
        } else {
            return (int) Math.ceil(d);
        }
    }
}
